Merge pull request #23587 from BrianBohe/brbohe/moving_variableLiveRange
[platform/upstream/coreclr.git] / build.sh
1 #!/usr/bin/env bash
2
3 # Work around Jenkins CI + msbuild problem: Jenkins sometimes creates very large environment
4 # variables, and msbuild can't handle environment blocks with such large variables. So clear
5 # out the variables that might be too large.
6 export ghprbCommentBody=
7
8 # resolve python-version to use
9 if [ "$PYTHON" == "" ] ; then
10     if ! PYTHON=$(command -v python3 || command -v python2 || command -v python || command -v py)
11     then
12        echo "Unable to locate build-dependency python!" 1>&2
13        exit 1
14     fi
15 fi
16 # validate python-dependency
17 # useful in case of explicitly set option.
18 if ! command -v $PYTHON > /dev/null
19 then
20    echo "Unable to locate build-dependency python ($PYTHON)!" 1>&2
21    exit 1
22 fi
23
24 export PYTHON
25
26 usage()
27 {
28     echo "Usage: $0 [BuildArch] [BuildType] [-verbose] [-coverage] [-cross] [-gccx.y] [-clangx.y] [-ninja] [-configureonly] [-skipconfigure] [-skipnative] [-skipcrossarchnative] [-skipmanaged] [-skipmscorlib] [-skiptests] [-stripsymbols] [-ignorewarnings] [-cmakeargs] [-bindir]"
29     echo "BuildArch can be: -x64, -x86, -arm, -armel, -arm64"
30     echo "BuildType can be: -debug, -checked, -release"
31     echo "-coverage - optional argument to enable code coverage build (currently supported only for Linux and OSX)."
32     echo "-ninja - target ninja instead of GNU make"
33     echo "-gccx.y - optional argument to build using gcc version x.y."
34     echo "-clangx.y - optional argument to build using clang version x.y."
35     echo "-cross - optional argument to signify cross compilation,"
36     echo "       - will use ROOTFS_DIR environment variable if set."
37     echo "-nopgooptimize - do not use profile guided optimizations."
38     echo "-pgoinstrument - generate instrumented code for profile guided optimization enabled binaries."
39     echo "-ibcinstrument - generate IBC-tuning-enabled native images when invoking crossgen."
40     echo "-configureonly - do not perform any builds; just configure the build."
41     echo "-skipconfigure - skip build configuration."
42     echo "-skipnative - do not build native components."
43     echo "-skipcrossarchnative - do not build cross-architecture native components."
44     echo "-skipmanaged - do not build managed components."
45     echo "-skipmscorlib - do not build mscorlib.dll."
46     echo "-skiptests - skip the tests in the 'tests' subdirectory."
47     echo "-skipnuget - skip building nuget packages."
48     echo "-skiprestoreoptdata - skip restoring optimization data used by profile-based optimizations."
49     echo "-skipcrossgen - skip native image generation"
50     echo "-crossgenonly - only run native image generation"
51     echo "-partialngen - build CoreLib as PartialNGen"
52     echo "-verbose - optional argument to enable verbose build output."
53     echo "-skiprestore: skip restoring packages ^(default: packages are restored during build^)."
54     echo "-disableoss: Disable Open Source Signing for System.Private.CoreLib."
55     echo "-officialbuildid=^<ID^>: specify the official build ID to be used by this build."
56     echo "-stripSymbols - Optional argument to strip native symbols during the build."
57     echo "-skipgenerateversion - disable version generation even if MSBuild is supported."
58     echo "-ignorewarnings - do not treat warnings as errors"
59     echo "-cmakeargs - user-settable additional arguments passed to CMake."
60     echo "-bindir - output directory (defaults to $__ProjectRoot/bin)"
61     echo "-msbuildonunsupportedplatform - build managed binaries even if distro is not officially supported."
62     echo "-numproc - set the number of build processes."
63     echo "-portablebuild - pass -portablebuild=false to force a non-portable build."
64     echo "-staticanalyzer - build with clang static analyzer enabled."
65     exit 1
66 }
67
68 initTargetDistroRid()
69 {
70     source init-distro-rid.sh
71
72     local passedRootfsDir=""
73
74     # Only pass ROOTFS_DIR if cross is specified.
75     if (( ${__CrossBuild} == 1 )); then
76         passedRootfsDir=${ROOTFS_DIR}
77     elif [ "${__BuildArch}" != "${__HostArch}" ]; then
78         echo "Error, you are building a cross scenario without passing -cross."
79         exit 1
80     fi
81
82     initDistroRidGlobal ${__BuildOS} ${__BuildArch} ${__PortableBuild} ${passedRootfsDir}
83 }
84
85 setup_dirs()
86 {
87     echo Setting up directories for build
88
89     mkdir -p "$__RootBinDir"
90     mkdir -p "$__BinDir"
91     mkdir -p "$__LogsDir"
92     mkdir -p "$__MsbuildDebugLogsDir"
93     mkdir -p "$__IntermediatesDir"
94
95     if [ $__CrossBuild == 1 ]; then
96         mkdir -p "$__CrossComponentBinDir"
97     fi
98 }
99
100 # Check the system to ensure the right prereqs are in place
101
102 check_prereqs()
103 {
104     echo "Checking prerequisites..."
105
106     # Check presence of CMake on the path
107     hash cmake 2>/dev/null || { echo >&2 "Please install cmake before running this script"; exit 1; }
108
109
110     # Minimum required version of clang is version 4.0 for arm/armel cross build
111     if [[ $__CrossBuild == 1 && $__GccBuild == 0 &&  ("$__BuildArch" == "arm" || "$__BuildArch" == "armel") ]]; then
112         if ! [[ "$__ClangMajorVersion" -ge "4" ]]; then
113             echo "Please install clang4.0 or latest for arm/armel cross build"; exit 1;
114         fi
115     fi
116
117     # Check for clang
118     if [[ $__GccBuild == 0 ]]; then
119         __ClangCombinedDottedVersion=$__ClangMajorVersion;
120         if [[ "$__ClangMinorVersion" != "" ]]; then
121             __ClangCombinedDottedVersion=$__ClangCombinedDottedVersion.$__ClangMinorVersion
122         fi
123         hash clang-$__ClangCombinedDottedVersion 2>/dev/null ||  hash clang$__ClangMajorVersion$__ClangMinorVersion 2>/dev/null || hash clang 2>/dev/null || { echo >&2 "Please install clang-$__ClangMajorVersion.$__ClangMinorVersion before running this script"; exit 1; }
124     else
125         __GccCombinedDottedVersion=$__GccMajorVersion;
126         if [[ "$__GccMinorVersion" != "" ]]; then
127             __GccCombinedDottedVersion=$__GccCombinedDottedVersion.$__GccMinorVersion
128         fi
129         hash gcc-$__GccCombinedDottedVersion 2>/dev/null ||  hash gcc$__GccMajorVersion$__GccMinorVersion 2>/dev/null || hash gcc 2>/dev/null || { echo >&2 "Please install gcc-$__GccMajorVersion.$__GccMinorVersion before running this script"; exit 1; }
130     fi
131
132 }
133
134 restore_optdata()
135 {
136     # we only need optdata on a Release build
137     if [[ "$__BuildType" != "Release" ]]; then __SkipRestoreOptData=1; fi
138
139     if [[ ( $__SkipRestoreOptData == 0 ) && ( $__isMSBuildOnNETCoreSupported == 1 ) ]]; then
140         echo "Restoring the OptimizationData package"
141         "$__ProjectRoot/dotnet.sh" msbuild /nologo /verbosity:minimal /clp:Summary \
142                                    /p:RestoreDefaultOptimizationDataPackage=false /p:PortableBuild=true \
143                                    /p:UsePartialNGENOptimization=false /maxcpucount \
144                                    /t:RestoreOptData ./build.proj \
145                                    $__CommonMSBuildArgs $__UnprocessedBuildArgs
146         if [ $? != 0 ]; then
147             echo "Failed to restore the optimization data package."
148             exit 1
149         fi
150     fi
151
152     if [ $__isMSBuildOnNETCoreSupported == 1 ]; then
153         # Parse the optdata package versions out of msbuild so that we can pass them on to CMake
154         local DotNetCli="$__ProjectRoot/.dotnet/dotnet"
155         if [ ! -f $DotNetCli ]; then
156             source "$__ProjectRoot/init-tools.sh"
157             if [ $? != 0 ]; then
158                 echo "Failed to restore buildtools."
159                 exit 1
160             fi
161         fi
162         local OptDataProjectFilePath="$__ProjectRoot/src/.nuget/optdata/optdata.csproj"
163         __PgoOptDataVersion=$(DOTNET_SKIP_FIRST_TIME_EXPERIENCE=1 $DotNetCli msbuild $OptDataProjectFilePath /t:DumpPgoDataPackageVersion /nologo | sed 's/^\s*//')
164         __IbcOptDataVersion=$(DOTNET_SKIP_FIRST_TIME_EXPERIENCE=1 $DotNetCli msbuild $OptDataProjectFilePath /t:DumpIbcDataPackageVersion /nologo | sed 's/^[[:blank:]]*//')
165     fi
166 }
167
168 generate_event_logging_sources()
169 {
170     __OutputDir=$1
171     __ConsumingBuildSystem=$2
172
173     __OutputIncDir="$__OutputDir/src/inc"
174     __OutputEventingDir="$__OutputDir/Eventing"
175     __OutputEventProviderDir="$__OutputEventingDir/eventprovider"
176
177     echo "Laying out dynamically generated files consumed by $__ConsumingBuildSystem"
178     echo "Laying out dynamically generated Event test files, etmdummy stub functions, and external linkages"
179
180     __PythonWarningFlags="-Wall"
181     if [[ $__IgnoreWarnings == 0 ]]; then
182         __PythonWarningFlags="$__PythonWarningFlags -Werror"
183     fi
184
185     $PYTHON -B $__PythonWarningFlags "$__ProjectRoot/src/scripts/genEventing.py" --inc $__OutputIncDir --dummy $__OutputIncDir/etmdummy.h --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --testdir "$__OutputEventProviderDir/tests"
186     if [[ $? != 0 ]]; then
187         exit 1
188     fi
189
190     echo "Laying out dynamically generated EventPipe Implementation"
191     $PYTHON -B $__PythonWarningFlags "$__ProjectRoot/src/scripts/genEventPipe.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --exc "$__ProjectRoot/src/vm/ClrEtwAllMeta.lst" --intermediate "$__OutputEventingDir/eventpipe"
192
193     echo "Laying out dynamically generated EventSource classes"
194     $PYTHON -B $__PythonWarningFlags "$__ProjectRoot/src/scripts/genRuntimeEventSources.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --intermediate "$__OutputEventingDir"
195
196     # determine the logging system
197     case $__BuildOS in
198         Linux|FreeBSD)
199             echo "Laying out dynamically generated Event Logging Implementation of Lttng"
200             $PYTHON -B $__PythonWarningFlags "$__ProjectRoot/src/scripts/genLttngProvider.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --intermediate "$__OutputEventProviderDir"
201             if [[ $? != 0 ]]; then
202                 exit 1
203             fi
204             ;;
205         *)
206             echo "Laying out dummy event logging provider"
207             $PYTHON -B $__PythonWarningFlags "$__ProjectRoot/src/scripts/genDummyProvider.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --intermediate "$__OutputEventProviderDir"
208             if [[ $? != 0 ]]; then
209                 exit 1
210             fi
211             ;;
212     esac
213 }
214
215 generate_event_logging()
216 {
217     # Event Logging Infrastructure
218     if [[ $__SkipCoreCLR == 0 || $__SkipMSCorLib == 0 || $__ConfigureOnly == 1 ]]; then
219         generate_event_logging_sources "$__IntermediatesDir" "the native build system"
220     fi
221 }
222
223 build_native()
224 {
225     skipCondition=$1
226     platformArch="$2"
227     intermediatesForBuild="$3"
228     extraCmakeArguments="$4"
229     message="$5"
230
231     if [ $skipCondition == 1 ]; then
232         echo "Skipping $message build."
233         return
234     fi
235
236     # All set to commence the build
237     echo "Commencing build of $message for $__BuildOS.$__BuildArch.$__BuildType in $intermediatesForBuild"
238
239     generator=""
240     buildFile="Makefile"
241     buildTool="make"
242     if [ $__UseNinja == 1 ]; then
243         generator="ninja"
244         buildFile="build.ninja"
245         if ! buildTool=$(command -v ninja || command -v ninja-build); then
246            echo "Unable to locate ninja!" 1>&2
247            exit 1
248         fi
249     fi
250
251     if [ $__SkipConfigure == 0 ]; then
252         # if msbuild is not supported, then set __SkipGenerateVersion to 1
253         if [ $__isMSBuildOnNETCoreSupported == 0 ]; then __SkipGenerateVersion=1; fi
254         # Drop version.c file
255         __versionSourceFile="$intermediatesForBuild/version.c"
256         if [ $__SkipGenerateVersion == 0 ]; then
257             pwd
258             "$__ProjectRoot/dotnet.sh" msbuild /nologo /verbosity:minimal /clp:Summary \
259                                        /l:BinClashLogger,Tools/Microsoft.DotNet.Build.Tasks.dll\;LogFile=binclash.log \
260                                        /p:RestoreDefaultOptimizationDataPackage=false /p:PortableBuild=true \
261                                        /p:UsePartialNGENOptimization=false /maxcpucount \
262                                        "$__ProjectDir/build.proj" /p:GenerateVersionSourceFile=true /t:GenerateVersionSourceFile /p:NativeVersionSourceFile=$__versionSourceFile \
263                                        $__CommonMSBuildArgs $__UnprocessedBuildArgs
264         else
265             # Generate the dummy version.c, but only if it didn't exist to make sure we don't trigger unnecessary rebuild
266             __versionSourceLine="static char sccsid[] __attribute__((used)) = \"@(#)No version information produced\";"
267             if [ -e $__versionSourceFile ]; then
268                 read existingVersionSourceLine < $__versionSourceFile
269             fi
270             if [ "$__versionSourceLine" != "$existingVersionSourceLine" ]; then
271                 echo $__versionSourceLine > $__versionSourceFile
272             fi
273         fi
274
275
276         pushd "$intermediatesForBuild"
277         # Regenerate the CMake solution
278
279         scriptDir="$__ProjectRoot/src/pal/tools"
280         if [[ $__GccBuild == 0 ]]; then
281             scan_build=
282             if [[ $__StaticAnalyzer == 1 ]]; then
283                 scan_build=scan-build
284             fi
285             echo "Invoking \"$scriptDir/gen-buildsys-clang.sh\" \"$__ProjectRoot\" $__ClangMajorVersion \"$__ClangMinorVersion\" $platformArch "$scriptDir" $__BuildType $__CodeCoverage $scan_build $generator $extraCmakeArguments $__cmakeargs"
286             source "$scriptDir/gen-buildsys-clang.sh" "$__ProjectRoot" $__ClangMajorVersion "$__ClangMinorVersion" $platformArch "$scriptDir" $__BuildType $__CodeCoverage $scan_build $generator "$extraCmakeArguments" "$__cmakeargs"
287         else
288             echo "Invoking \"$scriptDir/gen-buildsys-gcc.sh\" \"$__ProjectRoot\" $__GccMajorVersion \"$__GccMinorVersion\" $platformArch "$scriptDir" $__BuildType $__CodeCoverage $generator $extraCmakeArguments $__cmakeargs"
289             source "$scriptDir/gen-buildsys-gcc.sh" "$__ProjectRoot" "$__GccMajorVersion" "$__CGccMinorVersion" $platformArch "$scriptDir" $__BuildType $__CodeCoverage $generator "$extraCmakeArguments" "$__cmakeargs"
290         fi
291         popd
292     fi
293
294     if [ ! -f "$intermediatesForBuild/$buildFile" ]; then
295         echo "Failed to generate $message build project!"
296         exit 1
297     fi
298
299     # Build
300     if [ $__ConfigureOnly == 1 ]; then
301         echo "Finish configuration & skipping $message build."
302         return
303     fi
304
305     # Check that the makefiles were created.
306     pushd "$intermediatesForBuild"
307
308     if [ $__StaticAnalyzer == 1 ]; then
309         buildTool="$SCAN_BUILD_COMMAND $buildTool"
310     fi
311
312     echo "Executing $buildTool install -j $__NumProc"
313
314     $buildTool install -j $__NumProc
315     if [ $? != 0 ]; then
316         echo "Failed to build $message."
317         exit 1
318     fi
319
320     popd
321 }
322
323 build_cross_architecture_components()
324 {
325     local intermediatesForBuild="$__IntermediatesDir/Host$__CrossArch/crossgen"
326     local crossArchBinDir="$__BinDir/$__CrossArch"
327
328     mkdir -p "$intermediatesForBuild"
329     mkdir -p "$crossArchBinDir"
330
331     generate_event_logging_sources "$intermediatesForBuild" "the crossarch build system"
332
333     __SkipCrossArchBuild=1
334     # check supported cross-architecture components host(__HostArch)/target(__BuildArch) pair
335     if [[ ("$__BuildArch" == "arm" || "$__BuildArch" == "armel") && ("$__CrossArch" == "x86" || "$__CrossArch" == "x64") ]]; then
336         __SkipCrossArchBuild=0
337     elif [[ "$__BuildArch" == "arm64" && "$__CrossArch" == "x64" ]]; then
338         __SkipCrossArchBuild=0
339     else
340         # not supported
341         return
342     fi
343
344     export __CMakeBinDir="$crossArchBinDir"
345     export CROSSCOMPILE=0
346
347     __ExtraCmakeArgs="-DCLR_CMAKE_TARGET_ARCH=$__BuildArch -DCLR_CMAKE_TARGET_OS=$__BuildOS -DCLR_CMAKE_PACKAGES_DIR=$__PackagesDir -DCLR_CMAKE_PGO_INSTRUMENT=$__PgoInstrument -DCLR_CMAKE_OPTDATA_VERSION=$__PgoOptDataVersion -DCLR_CMAKE_PGO_OPTIMIZE=$__PgoOptimize -DCLR_CROSS_COMPONENTS_BUILD=1"
348     build_native $__SkipCrossArchBuild "$__CrossArch" "$intermediatesForBuild" "$__ExtraCmakeArgs" "cross-architecture components"
349
350     export CROSSCOMPILE=1
351 }
352
353 isMSBuildOnNETCoreSupported()
354 {
355     __isMSBuildOnNETCoreSupported=$__msbuildonunsupportedplatform
356
357     if [ $__isMSBuildOnNETCoreSupported == 1 ]; then
358         return
359     fi
360
361     if [ $__SkipManaged == 1 ]; then
362         __isMSBuildOnNETCoreSupported=0
363         return
364     fi
365
366     if [ "$__HostArch" == "x64" ]; then
367         if [ "$__HostOS" == "Linux" ]; then
368             __isMSBuildOnNETCoreSupported=1
369             # note: the RIDs below can use globbing patterns
370             UNSUPPORTED_RIDS=("ubuntu.17.04-x64")
371             for UNSUPPORTED_RID in "${UNSUPPORTED_RIDS[@]}"
372             do
373                 if [[ ${__DistroRid} == $UNSUPPORTED_RID ]]; then
374                     __isMSBuildOnNETCoreSupported=0
375                     break
376                 fi
377             done
378         elif [ "$__HostOS" == "OSX" ]; then
379             __isMSBuildOnNETCoreSupported=1
380         elif [ "$__HostOS" == "FreeBSD" ]; then
381             __isMSBuildOnNETCoreSupported=1
382         fi
383     fi
384 }
385
386
387 build_CoreLib_ni()
388 {
389     local __CrossGenExec=$1
390
391     if [ $__PartialNgen == 1 ]; then
392         export COMPlus_PartialNGen=1
393     fi
394
395     if [ -e $__CrossGenCoreLibLog ]; then
396         rm $__CrossGenCoreLibLog
397     fi
398     echo "Generating native image of System.Private.CoreLib.dll for $__BuildOS.$__BuildArch.$__BuildType. Logging to \"$__CrossGenCoreLibLog\"."
399     echo "$__CrossGenExec /Platform_Assemblies_Paths $__BinDir/IL $__IbcTuning /out $__BinDir/System.Private.CoreLib.dll $__BinDir/IL/System.Private.CoreLib.dll"
400     $__CrossGenExec /Platform_Assemblies_Paths $__BinDir/IL $__IbcTuning /out $__BinDir/System.Private.CoreLib.dll $__BinDir/IL/System.Private.CoreLib.dll >> $__CrossGenCoreLibLog 2>&1
401     if [ $? -ne 0 ]; then
402         echo "Failed to generate native image for System.Private.CoreLib. Refer to $__CrossGenCoreLibLog"
403         exit 1
404     fi
405
406     if [ "$__BuildOS" == "Linux" ]; then
407         echo "Generating symbol file for System.Private.CoreLib.dll"
408         echo "$__CrossGenExec /Platform_Assemblies_Paths $__BinDir /CreatePerfMap $__BinDir $__BinDir/System.Private.CoreLib.dll"
409         $__CrossGenExec /Platform_Assemblies_Paths $__BinDir /CreatePerfMap $__BinDir $__BinDir/System.Private.CoreLib.dll >> $__CrossGenCoreLibLog 2>&1
410         if [ $? -ne 0 ]; then
411             echo "Failed to generate symbol file for System.Private.CoreLib. Refer to $__CrossGenCoreLibLog"
412             exit 1
413         fi
414     fi
415 }
416
417 build_CoreLib()
418 {
419     if [ $__isMSBuildOnNETCoreSupported == 0 ]; then
420         echo "System.Private.CoreLib.dll build unsupported."
421         return
422     fi
423
424     if [ $__SkipMSCorLib == 1 ]; then
425        echo "Skipping building System.Private.CoreLib."
426        return
427     fi
428
429     echo "Commencing build of managed components for $__BuildOS.$__BuildArch.$__BuildType"
430
431     # Invoke MSBuild
432     __ExtraBuildArgs=""
433     if [[ "$__IbcTuning" == "" ]]; then
434         __ExtraBuildArgs="$__ExtraBuildArgs /p:OptimizationDataDir=\"$__PackagesDir/optimization.$__BuildOS-$__BuildArch.IBC.CoreCLR/$__IbcOptDataVersion/data\""
435         __ExtraBuildArgs="$__ExtraBuildArgs /p:EnableProfileGuidedOptimization=true"
436     fi
437
438     if [[ "$__BuildManagedTools" -eq "1" ]]; then
439         __ExtraBuildArgs="$__ExtraBuildArgs /p:BuildManagedTools=true"
440     fi
441
442     $__ProjectRoot/dotnet.sh restore /nologo /verbosity:minimal /clp:Summary \
443                              /l:BinClashLogger,Tools/Microsoft.DotNet.Build.Tasks.dll\;LogFile=binclash.log \
444                              /p:RestoreDefaultOptimizationDataPackage=false /p:PortableBuild=true \
445                              /p:UsePartialNGENOptimization=false /maxcpucount /p:IncludeRestoreOnlyProjects=true /p:ArcadeBuild=true\
446                              $__ProjectDir/src/build.proj \
447                              /flp:Verbosity=normal\;LogFile=$__LogsDir/System.Private.CoreLib_$__BuildOS__$__BuildArch__$__BuildType.log \
448                              /p:__IntermediatesDir=$__IntermediatesDir /p:__RootBinDir=$__RootBinDir /p:BuildNugetPackage=false \
449                              $__CommonMSBuildArgs $__ExtraBuildArgs $__UnprocessedBuildArgs
450
451     if [ $? -ne 0 ]; then
452         echo "Failed to restore managed components."
453         exit 1
454     fi
455
456     $__ProjectRoot/dotnet.sh msbuild /nologo /verbosity:minimal /clp:Summary \
457                              /l:BinClashLogger,Tools/Microsoft.DotNet.Build.Tasks.dll\;LogFile=binclash.log \
458                              /p:RestoreDefaultOptimizationDataPackage=false /p:PortableBuild=true \
459                              /p:UsePartialNGENOptimization=false /maxcpucount /p:DotNetUseShippingVersions=true /p:ArcadeBuild=true\
460                              $__ProjectDir/src/build.proj \
461                              /flp:Verbosity=normal\;LogFile=$__LogsDir/System.Private.CoreLib_$__BuildOS__$__BuildArch__$__BuildType.log \
462                              /p:__IntermediatesDir=$__IntermediatesDir /p:__RootBinDir=$__RootBinDir /p:BuildNugetPackage=false \
463                              $__CommonMSBuildArgs $__ExtraBuildArgs $__UnprocessedBuildArgs
464
465     if [ $? -ne 0 ]; then
466         echo "Failed to build managed components."
467         exit 1
468     fi
469
470     if [ $__SkipCrossgen == 1 ]; then
471         echo "Skipping generating native image"
472         return
473     fi
474
475     # The cross build generates a crossgen with the target architecture.
476     if [ $__CrossBuild == 0 ]; then
477        if [ $__SkipCoreCLR == 1 ]; then
478            return
479        fi
480
481        # The architecture of host pc must be same architecture with target.
482        if [[ ( "$__HostArch" == "$__BuildArch" ) ]]; then
483            build_CoreLib_ni "$__BinDir/crossgen"
484        elif [[ ( "$__HostArch" == "x64" ) && ( "$__BuildArch" == "x86" ) ]]; then
485            build_CoreLib_ni "$__BinDir/crossgen"
486        elif [[ ( "$__HostArch" == "arm64" ) && ( "$__BuildArch" == "arm" ) ]]; then
487            build_CoreLib_ni "$__BinDir/crossgen"
488        else
489            exit 1
490        fi
491     else
492        if [[ ( "$__CrossArch" == "x86" ) && ( "$__BuildArch" == "arm" ) ]]; then
493            build_CoreLib_ni "$__CrossComponentBinDir/crossgen"
494        elif [[ ( "$__CrossArch" == "x64" ) && ( "$__BuildArch" == "arm" ) ]]; then
495            build_CoreLib_ni "$__CrossComponentBinDir/crossgen"
496        elif [[ ( "$__HostArch" == "x64" ) && ( "$__BuildArch" == "arm64" ) ]]; then
497            build_CoreLib_ni "$__CrossComponentBinDir/crossgen"
498        fi
499     fi
500 }
501
502 generate_NugetPackages()
503 {
504     # We can only generate nuget package if we also support building mscorlib as part of this build.
505     if [ $__isMSBuildOnNETCoreSupported == 0 ]; then
506         echo "Nuget package generation unsupported."
507         return
508     fi
509
510     # Since we can build mscorlib for this OS, did we build the native components as well?
511     if [[ $__SkipCoreCLR == 1 && $__CrossgenOnly == 0 ]]; then
512         echo "Unable to generate nuget packages since native components were not built."
513         return
514     fi
515
516     echo "Generating nuget packages for "$__BuildOS
517     echo "DistroRid is "$__DistroRid
518     echo "ROOTFS_DIR is "$ROOTFS_DIR
519     # Build the packages
520     $__ProjectRoot/dotnet.sh msbuild /nologo /verbosity:minimal /clp:Summary \
521                              /l:BinClashLogger,Tools/Microsoft.DotNet.Build.Tasks.dll\;LogFile=binclash.log \
522                              /p:RestoreDefaultOptimizationDataPackage=false /p:PortableBuild=true \
523                              /p:UsePartialNGENOptimization=false /maxcpucount \
524                              $__SourceDir/.nuget/packages.builds \
525                              /flp:Verbosity=normal\;LogFile=$__LogsDir/Nuget_$__BuildOS__$__BuildArch__$__BuildType.log \
526                              /p:__IntermediatesDir=$__IntermediatesDir /p:__RootBinDir=$__RootBinDir /p:BuildNugetPackages=false /p:__DoCrossArchBuild=$__CrossBuild \
527                              $__CommonMSBuildArgs $__UnprocessedBuildArgs
528
529     if [ $? -ne 0 ]; then
530         echo "Failed to generate Nuget packages."
531         exit 1
532     fi
533 }
534
535 echo "Commencing CoreCLR Repo build"
536
537 # Argument types supported by this script:
538 #
539 # Build architecture - valid values are: x64, ARM.
540 # Build Type         - valid values are: Debug, Checked, Release
541 #
542 # Set the default arguments for build
543
544 # Obtain the location of the bash script to figure out where the root of the repo is.
545 __ProjectRoot="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
546
547 # Use uname to determine what the CPU is.
548 CPUName=$(uname -p)
549 # Some Linux platforms report unknown for platform, but the arch for machine.
550 if [ "$CPUName" == "unknown" ]; then
551     CPUName=$(uname -m)
552 fi
553
554 case $CPUName in
555     i686)
556         echo "Unsupported CPU $CPUName detected, build might not succeed!"
557         __BuildArch=x86
558         __HostArch=x86
559         ;;
560
561     x86_64)
562         __BuildArch=x64
563         __HostArch=x64
564         ;;
565
566     armv7l)
567         echo "Unsupported CPU $CPUName detected, build might not succeed!"
568         __BuildArch=arm
569         __HostArch=arm
570         ;;
571
572     aarch64)
573         __BuildArch=arm64
574         __HostArch=arm64
575         ;;
576
577     amd64)
578         __BuildArch=x64
579         __HostArch=x64
580         ;;
581     *)
582         echo "Unknown CPU $CPUName detected, configuring as if for x64"
583         __BuildArch=x64
584         __HostArch=x64
585         ;;
586 esac
587
588 # Use uname to determine what the OS is.
589 OSName=$(uname -s)
590 case $OSName in
591     Linux)
592         __BuildOS=Linux
593         __HostOS=Linux
594         ;;
595
596     Darwin)
597         __BuildOS=OSX
598         __HostOS=OSX
599         ;;
600
601     FreeBSD)
602         __BuildOS=FreeBSD
603         __HostOS=FreeBSD
604         ;;
605
606     OpenBSD)
607         __BuildOS=OpenBSD
608         __HostOS=OpenBSD
609         ;;
610
611     NetBSD)
612         __BuildOS=NetBSD
613         __HostOS=NetBSD
614         ;;
615
616     SunOS)
617         __BuildOS=SunOS
618         __HostOS=SunOS
619         ;;
620
621     *)
622         echo "Unsupported OS $OSName detected, configuring as if for Linux"
623         __BuildOS=Linux
624         __HostOS=Linux
625         ;;
626 esac
627
628 __BuildType=Debug
629 __CodeCoverage=
630 __IgnoreWarnings=0
631
632 # Set the various build properties here so that CMake and MSBuild can pick them up
633 __ProjectDir="$__ProjectRoot"
634 __SourceDir="$__ProjectDir/src"
635 __PackagesDir="${DotNetRestorePackagesPath:-${__ProjectDir}/packages}"
636 __RootBinDir="$__ProjectDir/bin"
637 __UnprocessedBuildArgs=
638 __CommonMSBuildArgs=
639 __MSBCleanBuildArgs=
640 __UseNinja=0
641 __VerboseBuild=0
642 __PgoInstrument=0
643 __PgoOptimize=1
644 __IbcTuning=""
645 __ConfigureOnly=0
646 __SkipConfigure=0
647 __SkipManaged=0
648 __SkipRestore=""
649 __SkipNuget=0
650 __SkipCoreCLR=0
651 __SkipCrossArchNative=0
652 __SkipMSCorLib=0
653 __SkipRestoreOptData=0
654 __SkipCrossgen=0
655 __CrossgenOnly=0
656 __PartialNgen=0
657 __SkipTests=0
658 __CrossBuild=0
659 __ClangMajorVersion=0
660 __ClangMinorVersion=0
661 __GccBuild=0
662 __GccMajorVersion=0
663 __GccMinorVersion=0
664 __NuGetPath="$__PackagesDir/NuGet.exe"
665 __DistroRid=""
666 __cmakeargs=""
667 __SkipGenerateVersion=0
668 __PortableBuild=1
669 __msbuildonunsupportedplatform=0
670 __PgoOptDataVersion=""
671 __IbcOptDataVersion=""
672 __BuildManagedTools=1
673 __SkipRestoreArg="/p:RestoreDuringBuild=true"
674 __SignTypeArg=""
675 __OfficialBuildIdArg=""
676 __StaticAnalyzer=0
677
678 # Get the number of processors available to the scheduler
679 # Other techniques such as `nproc` only get the number of
680 # processors available to a single process.
681 if [ `uname` = "FreeBSD" ]; then
682   __NumProc=`sysctl hw.ncpu | awk '{ print $2+1 }'`
683 elif [ `uname` = "NetBSD" ]; then
684   __NumProc=$(($(getconf NPROCESSORS_ONLN)+1))
685 elif [ `uname` = "Darwin" ]; then
686   __NumProc=$(($(getconf _NPROCESSORS_ONLN)+1))
687 else
688   __NumProc=$(nproc --all)
689 fi
690
691 while :; do
692     if [ $# -le 0 ]; then
693         break
694     fi
695
696     lowerI="$(echo $1 | awk '{print tolower($0)}')"
697     case $lowerI in
698         -\?|-h|--help)
699             usage
700             exit 1
701             ;;
702
703         x86|-x86)
704             __BuildArch=x86
705             ;;
706
707         x64|-x64)
708             __BuildArch=x64
709             ;;
710
711         arm|-arm)
712             __BuildArch=arm
713             ;;
714
715         armel|-armel)
716             __BuildArch=armel
717             ;;
718
719         arm64|-arm64)
720             __BuildArch=arm64
721             ;;
722
723         debug|-debug)
724             __BuildType=Debug
725             ;;
726
727         checked|-checked)
728             __BuildType=Checked
729             ;;
730
731         release|-release)
732             __BuildType=Release
733             ;;
734
735         coverage|-coverage)
736             __CodeCoverage=Coverage
737             ;;
738
739         cross|-cross)
740             __CrossBuild=1
741             ;;
742
743         -portablebuild=false)
744             __PortableBuild=0
745             ;;
746
747         verbose|-verbose)
748             __VerboseBuild=1
749             ;;
750
751         stripsymbols|-stripsymbols)
752             __cmakeargs="$__cmakeargs -DSTRIP_SYMBOLS=true"
753             ;;
754
755         clang3.5|-clang3.5)
756             __ClangMajorVersion=3
757             __ClangMinorVersion=5
758             ;;
759
760         clang3.6|-clang3.6)
761             __ClangMajorVersion=3
762             __ClangMinorVersion=6
763             ;;
764
765         clang3.7|-clang3.7)
766             __ClangMajorVersion=3
767             __ClangMinorVersion=7
768             ;;
769
770         clang3.8|-clang3.8)
771             __ClangMajorVersion=3
772             __ClangMinorVersion=8
773             ;;
774
775         clang3.9|-clang3.9)
776             __ClangMajorVersion=3
777             __ClangMinorVersion=9
778             ;;
779
780         clang4.0|-clang4.0)
781             __ClangMajorVersion=4
782             __ClangMinorVersion=0
783             ;;
784
785         clang5.0|-clang5.0)
786             __ClangMajorVersion=5
787             __ClangMinorVersion=0
788             ;;
789
790         clang6.0|-clang6.0)
791             __ClangMajorVersion=6
792             __ClangMinorVersion=0
793             ;;
794
795         clang7|-clang7)
796             __ClangMajorVersion=7
797             __ClangMinorVersion=
798             ;;
799
800         gcc5|-gcc5)
801             __GccMajorVersion=5
802             __GccMinorVersion=
803             __GccBuild=1
804             ;;
805
806         gcc6|-gcc6)
807             __GccMajorVersion=6
808             __GccMinorVersion=
809             __GccBuild=1
810             ;;
811
812         gcc7|-gcc7)
813             __GccMajorVersion=7
814             __GccMinorVersion=
815             __GccBuild=1
816             ;;
817
818         gcc8|-gcc8)
819             __GccMajorVersion=8
820             __GccMinorVersion=
821             __GccBuild=1
822             ;;
823
824         gcc|-gcc)
825             __GccMajorVersion=
826             __GccMinorVersion=
827             __GccBuild=1
828             ;;
829
830         ninja|-ninja)
831             __UseNinja=1
832             ;;
833
834         pgoinstrument|-pgoinstrument)
835             __PgoInstrument=1
836             ;;
837
838         nopgooptimize|-nopgooptimize)
839             __PgoOptimize=0
840             __SkipRestoreOptData=1
841             ;;
842
843         ibcinstrument|-ibcinstrument)
844             __IbcTuning="/Tuning"
845             ;;
846
847         configureonly|-configureonly)
848             __ConfigureOnly=1
849             __SkipMSCorLib=1
850             __SkipNuget=1
851             ;;
852
853         skipconfigure|-skipconfigure)
854             __SkipConfigure=1
855             ;;
856
857         skipnative|-skipnative)
858             # Use "skipnative" to use the same option name as build.cmd.
859             __SkipCoreCLR=1
860             ;;
861
862         skipcoreclr|-skipcoreclr)
863             # Accept "skipcoreclr" for backwards-compatibility.
864             __SkipCoreCLR=1
865             ;;
866
867         skipcrossarchnative|-skipcrossarchnative)
868             __SkipCrossArchNative=1
869             ;;
870
871         skipmanaged|-skipmanaged)
872             __SkipManaged=1
873             ;;
874
875         skipmscorlib|-skipmscorlib)
876             __SkipMSCorLib=1
877             ;;
878
879         skipgenerateversion|-skipgenerateversion)
880             __SkipGenerateVersion=1
881             ;;
882
883         skiprestoreoptdata|-skiprestoreoptdata)
884             __SkipRestoreOptData=1
885             ;;
886
887         skipcrossgen|-skipcrossgen)
888             __SkipCrossgen=1
889             ;;
890
891         crossgenonly|-crossgenonly)
892             __SkipMSCorLib=1
893             __SkipCoreCLR=1
894             __CrossgenOnly=1
895             ;;
896         partialngen|-partialngen)
897             __PartialNgen=1
898             ;;
899
900         skiptests|-skiptests)
901             __SkipTests=1
902             ;;
903
904         skipnuget|-skipnuget|skipbuildpackages|-skipbuildpackages)
905             __SkipNuget=1
906             ;;
907
908         ignorewarnings|-ignorewarnings)
909             __IgnoreWarnings=1
910             __cmakeargs="$__cmakeargs -DCLR_CMAKE_WARNINGS_ARE_ERRORS=OFF"
911             ;;
912
913         cmakeargs|-cmakeargs)
914             if [ -n "$2" ]; then
915                 __cmakeargs="$__cmakeargs $2"
916                 shift
917             else
918                 echo "ERROR: 'cmakeargs' requires a non-empty option argument"
919                 exit 1
920             fi
921             ;;
922
923         bindir|-bindir)
924             if [ -n "$2" ]; then
925                 __RootBinDir="$2"
926                 if [ ! -d $__RootBinDir ]; then
927                     mkdir $__RootBinDir
928                 fi
929                 __RootBinParent=$(dirname $__RootBinDir)
930                 __RootBinName=${__RootBinDir##*/}
931                 __RootBinDir="$(cd $__RootBinParent &>/dev/null && printf %s/%s $PWD $__RootBinName)"
932                 shift
933             else
934                 echo "ERROR: 'bindir' requires a non-empty option argument"
935                 exit 1
936             fi
937             ;;
938         msbuildonunsupportedplatform|-msbuildonunsupportedplatform)
939             __msbuildonunsupportedplatform=1
940             ;;
941         numproc|-numproc)
942             if [ -n "$2" ]; then
943               __NumProc="$2"
944               shift
945             else
946               echo "ERROR: 'numproc' requires a non-empty option argument"
947               exit 1
948             fi
949             ;;
950         osgroup|-osgroup)
951             if [ -n "$2" ]; then
952               __BuildOS="$2"
953               shift
954             else
955               echo "ERROR: 'osgroup' requires a non-empty option argument"
956               exit 1
957             fi
958             ;;
959         rebuild|-rebuild)
960             echo "ERROR: 'Rebuild' is not supported.  Please remove it."
961             exit 1
962             ;;
963
964         -skiprestore)
965             __SkipRestoreArg="/p:RestoreDuringBuild=false"
966             ;;
967
968         -disableoss)
969             __SignTypeArg="/p:SignType=real"
970             ;;
971
972         -officialbuildid=*)
973             __Id=$(echo $1| cut -d'=' -f 2)
974             __OfficialBuildIdArg="/p:OfficialBuildId=$__Id"
975             ;;
976
977         -staticanalyzer)
978             __StaticAnalyzer=1
979             ;;
980
981         --)
982             # Skip -Option=Value style argument passing
983             ;;
984
985         *)
986             __UnprocessedBuildArgs="$__UnprocessedBuildArgs $1"
987             ;;
988     esac
989
990     shift
991 done
992
993 __CommonMSBuildArgs="/p:__BuildArch=$__BuildArch /p:__BuildType=$__BuildType /p:__BuildOS=$__BuildOS $__OfficialBuildIdArg $__SignTypeArg $__SkipRestoreArg"
994
995 # Configure environment if we are doing a verbose build
996 if [ $__VerboseBuild == 1 ]; then
997     export VERBOSE=1
998     __CommonMSBuildArgs="$__CommonMSBuildArgs /v:detailed"
999 fi
1000
1001 # Set default clang version
1002 if [[ $__ClangMajorVersion == 0 && $__ClangMinorVersion == 0 ]]; then
1003     if [[ "$__BuildArch" == "arm" || "$__BuildArch" == "armel" ]]; then
1004         __ClangMajorVersion=5
1005         __ClangMinorVersion=0
1006     else
1007         __ClangMajorVersion=3
1008         __ClangMinorVersion=9
1009     fi
1010 fi
1011
1012 if [[ "$__BuildArch" == "armel" ]]; then
1013     # Armel cross build is Tizen specific and does not support Portable RID build
1014     __PortableBuild=0
1015 fi
1016
1017 if [ $__PortableBuild == 0 ]; then
1018     __CommonMSBuildArgs="$__CommonMSBuildArgs /p:PortableBuild=false"
1019 fi
1020
1021 # Set dependent variables
1022 __LogsDir="$__RootBinDir/Logs"
1023 __MsbuildDebugLogsDir="$__LogsDir/MsbuildDebugLogs"
1024
1025 # Set the remaining variables based upon the determined build configuration
1026 __BinDir="$__RootBinDir/Product/$__BuildOS.$__BuildArch.$__BuildType"
1027 __PackagesBinDir="$__BinDir/.nuget"
1028 __ToolsDir="$__RootBinDir/tools"
1029 __TestWorkingDir="$__RootBinDir/tests/$__BuildOS.$__BuildArch.$__BuildType"
1030 export __IntermediatesDir="$__RootBinDir/obj/$__BuildOS.$__BuildArch.$__BuildType"
1031 __TestIntermediatesDir="$__RootBinDir/tests/obj/$__BuildOS.$__BuildArch.$__BuildType"
1032 __isMSBuildOnNETCoreSupported=0
1033 __CrossComponentBinDir="$__BinDir"
1034
1035 __CrossArch="$__HostArch"
1036 if [ $__CrossBuild == 1 ]; then
1037     __CrossComponentBinDir="$__CrossComponentBinDir/$__CrossArch"
1038 fi
1039 __CrossGenCoreLibLog="$__LogsDir/CrossgenCoreLib_$__BuildOS.$__BuildArch.$__BuildType.log"
1040
1041 # init the target distro name
1042 initTargetDistroRid
1043
1044 # Init if MSBuild for .NET Core is supported for this platform
1045 isMSBuildOnNETCoreSupported
1046
1047 # CI_SPECIFIC - On CI machines, $HOME may not be set. In such a case, create a subfolder and set the variable to set.
1048 # This is needed by CLI to function.
1049 if [ -z "$HOME" ]; then
1050     if [ ! -d "$__ProjectDir/temp_home" ]; then
1051         mkdir temp_home
1052     fi
1053     export HOME=$__ProjectDir/temp_home
1054     echo "HOME not defined; setting it to $HOME"
1055 fi
1056
1057 # Specify path to be set for CMAKE_INSTALL_PREFIX.
1058 # This is where all built CoreClr libraries will copied to.
1059 export __CMakeBinDir="$__BinDir"
1060
1061 # Configure environment if we are doing a cross compile.
1062 if [ $__CrossBuild == 1 ]; then
1063     export CROSSCOMPILE=1
1064     if ! [[ -n "$ROOTFS_DIR" ]]; then
1065         export ROOTFS_DIR="$__ProjectRoot/cross/rootfs/$__BuildArch"
1066     fi
1067 fi
1068
1069 # Make the directories necessary for build if they don't exist
1070 setup_dirs
1071
1072 # Set up the directory for MSBuild debug logs.
1073 export MSBUILDDEBUGPATH="${__MsbuildDebugLogsDir}"
1074
1075 # Check prereqs.
1076 check_prereqs
1077
1078 # Restore the package containing profile counts for profile-guided optimizations
1079 restore_optdata
1080
1081 # Generate event logging infrastructure sources
1082 generate_event_logging
1083
1084 # Build the coreclr (native) components.
1085 __ExtraCmakeArgs="-DCLR_CMAKE_TARGET_OS=$__BuildOS -DCLR_CMAKE_PACKAGES_DIR=$__PackagesDir -DCLR_CMAKE_PGO_INSTRUMENT=$__PgoInstrument -DCLR_CMAKE_OPTDATA_VERSION=$__PgoOptDataVersion -DCLR_CMAKE_PGO_OPTIMIZE=$__PgoOptimize"
1086
1087 # [TODO] Remove this when the `build-test.sh` script properly builds and deploys test assets.
1088 if [ $__SkipTests != 1 ]; then
1089     echo "Adding CMake flags to build native tests for $__BuildOS.$__BuildArch.$__BuildType"
1090     __ExtraCmakeArgs="$__ExtraCmakeArgs -DCLR_CMAKE_BUILD_TESTS=ON"
1091 fi
1092
1093 build_native $__SkipCoreCLR "$__BuildArch" "$__IntermediatesDir" "$__ExtraCmakeArgs" "CoreCLR component"
1094
1095 # Build cross-architecture components
1096 if [ $__SkipCrossArchNative != 1 ]; then
1097     if [[ $__CrossBuild == 1 ]]; then
1098         build_cross_architecture_components
1099     fi
1100 fi
1101
1102 # Build System.Private.CoreLib.
1103
1104 build_CoreLib
1105
1106 if [ $__CrossgenOnly == 1 ]; then
1107     build_CoreLib_ni "$__BinDir/crossgen"
1108 fi
1109
1110 # Generate nuget packages
1111 if [ $__SkipNuget != 1 ]; then
1112     generate_NugetPackages
1113 fi
1114
1115
1116 # Build complete
1117
1118 echo "Repo successfully built."
1119 echo "Product binaries are available at $__BinDir"
1120 exit 0